/*                                                           Pontificia Universidade Catolica
 *  Campinas - Sao Paulo - Brasil
 *  dez/2004
 *
 * 	Projeto Semestral - Sistemas Operacionais 2
 *
 *	Camada Independente de Dispositivos : DRIVER 
 * 
 *	Desenvolvedor:  	Cesar Kallas		:RA 02099224	cesarkallas@gmx.net
 *					
 *	ESSE DRIVER PRECISA DO DIRETORIO BFD QUE FICA NO MSM DIRETORIO DESSE ARQUIVO
 *	ESSE NAO EH UM ARQUIVO DE TESTES
 * Ultima atualizacao: 09/12/2004
 */
 
#include "lib.h"


void driver(void);

int main(int argc, char argv)
{
	// As vezes da uns problemas de buffer na fila de mensagem, por isso eu sempre removo ela
	// antes de criar novamente, pode acontecer o driver sofrer um segment fault e nao descarregar a fila
	// por isso tem essas linhas abaixo
	if(msgctl(msg_cid, IPC_RMID, NULL) != 0 )
		print("[driver.c:main] Impossivel remover a fila");
	else
		print("[driver.c:main] Removendo a fila de mensagem");
	
	/* Cria a fila de mensagens que sera usada na comunicacao com o Driver, modo 0666 significa que 
	qualquer um pode ler e escrever nessa fila.  */
	if( (msg_cid = msgget(MSG_CID, IPC_CREAT | 0666)) == -1 )
	{
		print("[driver.c:main] Impossivel criar fila de mensagem");
		return -1;
	}
	else
		print("[driver.c:main] Fila de mensagem criada");

	// Chama o driver
	driver();
	
	print("[driver.c:main] Driver parou de executar");
	
	if(msgctl(msg_cid, IPC_RMID, NULL) != 0 )
		print("[driver.c:main] Impossivel remover a fila");
	else
		print("[driver.c:main] Removendo a fila de mensagem");
}

// Essa funcao somente consulta a bfd em disco
int consulta_bfd(void)
{
	int tam_bfd=0, i;
	FILE *bfdfile;
	
	char arquivo[TAM_MAX_URL];
	char arquivo2[TAM_MAX_URL];
	strcpy(arquivo, "bfd/");
	sprintf(arquivo2, "%d", requisicao->index);
	strcat(arquivo, arquivo2);
	
	bfdfile = fopen(arquivo, "rt");
	
	if(bfdfile==NULL)
	{
		print("[driver.c:consulta_bfd] Erro ao consultar BFD, arquivo nao existe");
		return -1;
	}else
		print("[driver.c:consulta_bfd] Consultando bfd no disco");
	
	char tipo; int pb;
	char c;
	
	// Quanta qts linhas tem o arquivo
	// eh util para eu criar a memoria compartilhada do tamanho exato
	while(!feof(bfdfile))
	{
		fscanf(bfdfile,"%c", &c);
		if(c=='\n')
				tam_bfd++;
	} 
	tam_bfd--;	// -1 porque ele coonta a ultima linha em branco do arquivo
	
	fclose(bfdfile);
	bfdfile = fopen(arquivo, "rt");	//abre e fecha o arquivo, pra retornar o ponteiro de leitura pro comeco do arquivo
	
	// Cria memoria compartilhada do BFD
	if((shm_bfd = shmget(SHM_BFD,(tam_bfd*sizeof(BFD)),IPC_CREAT | 0666))==-1)
		print("[driver.c:consulta_bfd] Erro ao criar a memoria compartilhada da BFD");
	
	// Inicia a memoria compartilhada do BFD
	if((bfd = (BFD *) shmat(shm_bfd, NULL, 0))==(BFD *) -1)
		print("[driver.c:consulta_bfd] Erro ao iniciar a memoria compartilhada do BFD");

	// Le do arquivo o BFD
	for(i=0; i<tam_bfd; i++)
		fscanf(bfdfile, "%i\t%i", &bfd[i].tipo, &bfd[i].primeiro_bloco);
	
	// Imprime bfd lido
	for(i=0; i<tam_bfd; i++)
	{
		prints("[driver.c:consulta_bfd]\t\t");
		printi(bfd[i].tipo);
		prints("\t");
		printi(bfd[i].primeiro_bloco);
		prints("\n");
	}
	
	// Retorna pro drive o tam_bfd, esse sera o status que o driver retorna pro cid
	return tam_bfd;
}
	
// Mesma funcao da funcao acima, com diferenca que le outros blocos e nao o bfd
int consulta_bloco(void)
{
	int tam_bloco=0, i;
	FILE *blocofile;
	
	char arquivo[50];
	char arquivo2[50];
	strcpy(arquivo, "bfd/");
	sprintf(arquivo2, "%d", requisicao->index);
	strcat(arquivo, arquivo2);
	
	blocofile = fopen(arquivo, "rt");
	
	if(blocofile==NULL)
	{
		print("[driver.c:consulta_bloco] Erro ao consultar no disco o bloco ");
		printi(requisicao->index);
		return -1;
	}else
	{
		prints("[driver.c:consulta_bloco] Consultando no disco o bloco: ");
		printi(requisicao->index);
		prints("\n");
	}
	
	char tipo; int pb;
	char c;
	
	while(!feof(blocofile))
	{
		fscanf(blocofile,"%c", &c);
		if(c=='\n')
				tam_bloco++;
	}
	tam_bloco--;
	
	fclose(blocofile);
	blocofile = fopen(arquivo, "rt");
	
	// Cria memoria compartilhada do BUFFER
	if((shm_buffer = shmget(SHM_BUFFER,(tam_bloco * sizeof(BUFFER)),IPC_CREAT | 0666))==-1)
		print("[driver.c:consulta_bloco] Erro ao criar a memoria compartilhada do BUFFER");
	
	// Inicia a memoria compartilhada do BUFFER
	if((buffer = (BUFFER *) shmat(shm_buffer, NULL, 0))==(BUFFER *) -1)
		print("[driver.c:consulta_bloco] Erro ao iniciar a memoria compartilhada do BUFFER");

	char nome[100];
	char index;
	char ch;
	int j=0;
	for(i=0; i<tam_bloco; i++)
	{
		j=0;
		fscanf(blocofile, "%i", &buffer[i].index);
		ch=getc(blocofile);
		while(1)
		{
			fscanf(blocofile,"%c", &ch);
			if(ch=='\n')
				break;
			nome[j]=ch;
			j++;
		}
		nome[j]='\0';
		strcpy(buffer[i].nome, nome);
		prints("[driver.c:consulta_bloco]\t");
		printi(buffer[i].index);
		prints("\t");
		prints(buffer[i].nome);
		prints("\n");
	}
	
	return tam_bloco;
}

void driver(void)
{
	int escutar=0;
	buffer_resposta.mtype=1;
	
	// Driver fica na ativa ate mandar parar (na verdade ele nunca deveria parar, mas tem a opcao :)
	while(escutar==0)
	{
		print("[driver.c:driver] Driver escutando");
		
		// REQUISICAO  da CID
		if(msgrcv(msg_cid,(struct msgbuf *)&buffer_requisicao,sizeof(REQUISICAO),1,0) == -1 )
		{
			print("[driver.c:driver Impossivel receber mensagem de requisicao");
			exit(1);
		}else{
			#ifdef PRINT
			fflush(stdout);
			fflush(stderr);
			printf("[driver.c:driver] Driver recebeu requisicao: %i\n", requisicao->operacao);
			fflush(stdout);
			fflush(stderr);
			#endif
		}
		
		switch(requisicao->operacao)
		{
			// Le bfd
			case 1:
			{
				resposta->status=consulta_bfd();
				break;
			}
			
			// Le outros blocos
			case 2:
			{
				resposta->status=consulta_bloco();
				break;
			}
			
			case 999: escutar=-1;
	
			default: {}
		}
		
		// Esse tempo se faz necessario, porque eh visivel o driver ficar imprimindo coisas
		// sem sentido no terminal, mas quando tem esse tempo isso nao acontece
		// esse tempo eh um chute, coloquei, funcionou, blz
		usleep(100000);
		
		// REPOSTA PARA a CID
		if( msgsnd(msg_cid,(struct msgbuf *)&buffer_resposta, sizeof(RESPOSTA),0) ==-1 )
		{
			print("[driver.c:driver] Driver nao conseguiu enviar resposta da requisicao!");
			exit(1);
		}else{
			#ifdef PRINT
			fflush(stdout);
			fflush(stderr);
			printf("[driver.c:driver] Driver enviando resposta: %i\n", resposta->status);
			fflush(stdout);
			fflush(stderr);
			#endif
		}
	}
}


/*
 descarte


	/* Thread do driver
	if(pthread_create(&DRIVER_T, NULL, (void *)driver, NULL))
		print("[driver.c:main] Impossivel criar thread driver");
	else
		print("[driver.c:main] Thread do driver iniciada");
	
	pthread_join(DRIVER_T, (void **)&status);

		//case 999: pthread_exit(NULL);

typedef struct
{
	unsigned short int tipo;			/* tipo do arquivo (arquivo / diretorio) 
	//unsigned int data_criacao;			/* data da criacao do arquivo 
	//unsigned int data_ultima_modificao;		/* data da ultima moficacao feita no arquivo 
	//unsigned short int atributo;			/* atributo do arquivo (leitura, escrita, leitura e escrita 
	unsigned int primeiro_bloco;			/* numero que corresponde ao primeiro bloco de dados 
	unsigned int tamanho;				/* tamanho do arquivo 
} BFD;
BFD *bfd;		/* o bfd no pior caso, onde cada arquivo ocupa 1 bloco tera N entradas no BFD 

*/
